<?php
/**
 * MyShowcase Plugin for MyBB - Code for New and Edit 
 * Copyright � 2010 PavementSucks.com, All Rights Reserved
 *
 * Website: http://www.pavementsucks.com/plugins.html
 * Version 2.2.1
 * License: Creative Commons Attribution-NonCommerical ShareAlike 3.0
				http://creativecommons.org/licenses/by-nc-sa/3.0/legalcode
 * File: \inc\plugins\myshowcase\myshowcase_newedit.php (this file is renamed for multiple showcase versions)
 *
 */

switch($mybb->input['action'])
{
	case "edit":
	{
		if(!$mybb->user['uid'] || !$me->userperms['canedit'])
		{
			error($lang->myshowcase_not_authorized);
		}

		$mybb->input['gid'] = intval($mybb->input['gid']);

		if(!$mybb->input['gid'] || $mybb->input['gid'] == "")
		{
			error($lang->myshowcase_invalid_id);
		}

		$query = $db->simple_select($me->table_name, "*", "gid=".$mybb->input['gid']);
		if($db->num_rows($query) == 0)
		{
			error($lang->myshowcase_invalid_id);
		}

		$showcase_data = $db->fetch_array($query);

		//make sure current user is moderator or the myshowcase author
		if(!$me->userperms['canmodedit'] && $mybb->user['uid'] != $showcase_data['uid'])
		{
			error($lang->myshowcase_not_authorized);
		}

		//since its possible for a mod to edit another user's showcase, we need to get authors info/permimssions
		//get showcase author info
		$showcase_user = get_user($showcase_data['uid']);

		//set value for author id in form hidden fields so we know if current user is author
		$showcase_authid = $showcase_user['uid'];

		//get permissions for user
		$showcase_authorperms = $me->get_user_permissions($showcase_user);

		$mybb->input['posthash'] = $showcase_data['posthash'];
		$posthash = $mybb->input['posthash'];

	//no break since edit will share NEW code
	}
	case "new":
	{
		$can_add_attachments = $me->userperms['canattach'];
		$attach_limit = $me->userperms['attachlimit'];

		if($mybb->input['action'] == "new")
		{
			add_breadcrumb($lang->myshowcase_new, SHOWCASE_URL);
			$showcase_action = 'do_newshowcase';
		}
		elseif($mybb->input['action'] == "edit")
		{
			$showcase_editing_user = str_replace("{username}", $showcase_user['username'], $lang->myshowcase_editing_user);
			add_breadcrumb($showcase_editing_user, SHOWCASE_URL);
			$showcase_action = 'do_editshowcase';

			//if editing, adjust permissions depending on mod or actual author
			if(is_array($showcase_authorperms))
			{
				$can_add_attachments = $showcase_authorperms['canattach'];
				$attach_limit = $showcase_authorperms['attachlimit'];
			}
		}

		if(($mybb->input['action'] == "new" && $me->userperms['canadd']) || ($mybb->input['action'] == "edit" &&($me->userperms['canedit'] || $me->userperms['canmodedit'])))
		{
			$plugins->run_hooks("myshowcase_editnew_start");

			// Setup our posthash for managing attachments.
			if(!$mybb->input['posthash'])
			{
				mt_srand ((double) microtime() * 1000000);
				$mybb->input['posthash'] = md5($mybb->user['uid'].mt_rand());
			}
			$posthash = $mybb->input['posthash'];

			// Get a listing of the current attachments.
			if($can_add_attachments)
			{
				$attachcount = 0;
				$attachwhere = "posthash='".$db->escape_string($posthash)."'";

				$attachments = '';
				$query = $db->simple_select("myshowcase_attachments", "*", $attachwhere);
				while($attachment = $db->fetch_array($query))
				{
					$attachment['size'] = get_friendly_size($attachment['filesize']);
					$attachment['icon'] = get_attachment_icon(get_extension($attachment['filename']));
					$attachment['icon'] = str_replace('<img src="', '<img src="'.$mybb->settings['bburl'].'/', $attachment['icon']);
					
					$attach_mod_options = '';
					if($attachment['visible'] != 1)
					{
						eval("\$attachments .= \"".$templates->get("myshowcase_new_attachments_attachment_unapproved")."\";");
					}
					else
					{
						eval("\$attachments .= \"".$templates->get("myshowcase_new_attachments_attachment")."\";");
					}
					$attachcount++;
				}
				$lang->myshowcase_attach_quota = $lang->sprintf($lang->myshowcase_attach_quota, $attachcount, ($attach_limit == -1 ? $lang->myshowcase_unlimited : $attach_limit)).'<br>';
				if($attach_limit == -1 || ($attach_limit != -1 && $attachcount < $attach_limit))
				{
					eval("\$showcase_new_attachments_input = \"".$templates->get("myshowcase_new_attachments_input")."\";");
				}

				if($showcase_new_attachments_input != '' || $attachments != '')
				{
					eval("\$showcase_attachments = \"".$templates->get("myshowcase_new_attachments")."\";");
				}
			}

			eval("\$showcase_page .= \"".$templates->get("myshowcase_new_top")."\";");

			$trow_style = "trow2";

			reset($showcase_fields_enabled);

			foreach ($showcase_fields_enabled as $fname => $ftype)
			{

				$temp = 'myshowcase_field_'.$fname;
				$field_header = $lang->$temp;

				$trow_style = ($trow_style == "trow1" ? "trow2" : "trow1");

				if($mybb->input['action'] == "edit")
				{
					$mybb->input['myshowcase_field_'.$fname] = htmlspecialchars_uni(stripslashes($showcase_data[$fname]));
				}

				switch( $ftype)
				{
					case "textbox":
						$showcase_field_width = 50;
						$showcase_field_rows = '';
						$showcase_field_name = 'myshowcase_field_'.$fname;
						$showcase_field_value = $mybb->input['myshowcase_field_'.$fname];
						$showcase_field_enabled = '';//($showcase_fields_enabled[$fname] != 1 ? 'disabled' : '');
						$showcase_field_checked = '';
						$showcase_field_options = 'maxlength="'.$showcase_fields_max_length[$fname].'"';
						eval("\$showcase_field_input = \"".$templates->get("myshowcase_field_textbox")."\";");
						
						if($showcase_fields_format[$fname] != 'no')
						{
							$showcase_field_input .= '&nbsp;'.$lang->myshowcase_editing_number;
						}
					break;

					case "textarea":
						$showcase_field_width = 100;
						$showcase_field_rows = $showcase_fields_max_length[$fname];
						$showcase_field_name = 'myshowcase_field_'.$fname;
						$showcase_field_value = $mybb->input['myshowcase_field_'.$fname];
						$showcase_field_enabled = '';//($showcase_fields_enabled[$fname] != 1 ? 'disabled' : '');
						$showcase_field_checked = '';
						$showcase_field_options = '';
						eval("\$showcase_field_input = \"".$templates->get("myshowcase_field_textarea")."\";");
					break;

					case "radio":
						$showcase_field_width = 50;
						$showcase_field_rows = '';
						$showcase_field_name = 'myshowcase_field_'.$fname;
						$showcase_field_enabled = '';// ($showcase_fields_enabled[$fname] != 1 ? 'disabled' : '');
						$showcase_field_options = '';

						$query = $db->simple_select("myshowcase_field_data", "*", "setid=".$me->fieldsetid." AND name='".$fname."' AND valueid != 0", array("order_by" => "disporder"));
						if($db->num_rows($query) == 0)
						{
							error($lang->myshowcase_db_no_data);
						}

						$showcase_field_input = '';
						while($results = $db->fetch_array($query))
						{
							$showcase_field_value = $results['valueid'];
							$showcase_field_checked = ($mybb->input['myshowcase_field_'.$fname] == $results['valueid'] ? ' checked' : '');
							$showcase_field_text = $results['value'];
							eval("\$showcase_field_input .= \"".$templates->get("myshowcase_field_radio")."\";");
						}
					break;

					case "checkbox":
						$showcase_field_width = 50;
						$showcase_field_rows = '';
						$showcase_field_name = 'myshowcase_field_'.$fname;
						$showcase_field_value = '1';
						$showcase_field_enabled = '';//($showcase_fields_enabled[$fname] != 1 ? 'disabled' : '');
						$showcase_field_checked = ($mybb->input['myshowcase_field_'.$fname] == 1 ? ' checked="checked"' : '');
						$showcase_field_options = '';
						eval("\$showcase_field_input = \"".$templates->get("myshowcase_field_checkbox")."\";");
					break;

					case "db":
						$showcase_field_width = 50;
						$showcase_field_rows = '';
						$showcase_field_name = 'myshowcase_field_'.$fname;
						$showcase_field_value = $mybb->input['myshowcase_field_'.$fname];
						$showcase_field_enabled = '';//($showcase_fields_enabled[$fname] != 1 ? 'disabled' : '');
						$showcase_field_checked = '';
						$query = $db->simple_select("myshowcase_field_data", "*", "setid=".$me->fieldsetid." AND name='".$fname."' AND valueid != 0", array("order_by" => "disporder"));
						if($db->num_rows($query) == 0)
						{
							error($lang->myshowcase_db_no_data);
						}

						$showcase_field_options = ($mybb->input['action'] == "new" ? '<option value=0>&lt;Select&gt;</option>' : '');
						while($results = $db->fetch_array($query))
						{
							$showcase_field_options .= '<option value="'.$results['valueid'].'" '.($showcase_field_value == $results['valueid'] ? ' selected' : '') .'>'.$results['value'].'</option>';
						}
						eval("\$showcase_field_input = \"".$templates->get("myshowcase_field_db")."\";");
					break;
				}

				$field_header = ($showcase_fields_require[$fname] ? "<strong>".$field_header." *</strong>" : $field_header);
				eval("\$showcase_page .= \"".$templates->get("myshowcase_new_fields")."\";");
			}

			$plugins->run_hooks("myshowcase_editnew_end");

			eval("\$showcase_page .= \"".$templates->get("myshowcase_new_bottom")."\";");
		}
		else
		{
			error($lang->myshowcase_not_authorized);
		}
	break;
	}
	case "do_editshowcase":
	{
		$query = $db->simple_select($me->table_name, "*", "gid=".intval($mybb->input['gid']));
		if($db->num_rows($query) == 0)
		{
			error($lang->myshowcase_invalid_id);
		}

		$showcase_data = $db->fetch_array($query);

		//get posters info
		$showcase_user = get_user($showcase_data['uid']);

		//set value for author id in form hidden fields so we know if current user is author
		$showcase_authid = $showcase_user['uid'];

		//since its possible for a mod to edit another user's showcase, we need to re-evaluate  permimssions for poster
		if($me->userperms['canmodedit'] && $mybb->user['uid'] != $showcase_data['uid'])
		{
			//get permissions for user
			$showcase_authorperms = $me->get_user_permissions($showcase_user);
		}

		//if editing, adjust permissions depending on mod or actual user
		if(is_array($showcase_authorperms))
		{
			$can_add_attachments = $showcase_authorperms['canattach'];
			$attach_limit = $showcase_authorperms['attachlimit'];
		}
		else
		{
			$can_add_attachments = $me->userperms['canattach'];
			$attach_limit = $me->userperms['attachlimit'];
		}

	}
	//no break since sharing code
	case "do_newshowcase":
	{
		if($mybb->input['action'] == "do_newshowcase")
		{
			add_breadcrumb($lang->myshowcase_new, SHOWCASE_URL);
			$showcase_action = 'do_newshowcase';

			//need to populated a default user value here for new entries
			$showcase_data['uid'] = $mybb->user['uid'];

			//get perms if new
			$can_add_attachments = $me->userperms['canattach'];
			$attach_limit = $me->userperms['attachlimit'];
		}
		else
		{
			$showcase_editing_user = str_replace("{username}", $showcase_user['username'], $lang->myshowcase_editing_user);
			add_breadcrumb($showcase_editing_user, SHOWCASE_URL);
			$showcase_action = 'do_editshowcase';
		}

		// Setup our posthash for managing attachments.
		if(!$mybb->input['posthash'])
		{
			mt_srand ((double) microtime() * 1000000);
			$mybb->input['posthash'] = md5($mybb->user['uid'].mt_rand());
		}
		$posthash = $db->escape_string($mybb->input['posthash']);

		// Get a listing of the current attachments.
		if($can_add_attachments == 1)
		{
			$attachcount = 0;
			$attachwhere = "id=".$me->id." AND posthash='".$posthash."'";

			$attachments = '';
			$query = $db->simple_select("myshowcase_attachments", "*", $attachwhere);
			while($attachment = $db->fetch_array($query))
			{
				$attachment['size'] = get_friendly_size($attachment['filesize']);
				$attachment['icon'] = get_attachment_icon(get_extension($attachment['local']));

				$attach_mod_options = '';
				if($attachment['visible'] != 1)
				{
					eval("\$attachments .= \"".$templates->get("myshowcase_new_attachments_attachment_unapproved")."\";");
				}
				else
				{
					eval("\$attachments .= \"".$templates->get("myshowcase_new_attachments_attachment")."\";");
				}
				$attachcount++;
			}
			$lang->myshowcase_attach_quota = $lang->sprintf($lang->myshowcase_attach_quota, $attachcount, ($attach_limit == -1 ? $lang->myshowcase_unlimited : $attach_limit)).'<br>';
			if($attach_limit == -1 || ($attach_limit != 0 && ($attachcount < $attach_limit)))
			{
				eval("\$showcase_new_attachments_input = \"".$templates->get("myshowcase_new_attachments_input")."\";");
			}
			eval("\$showcase_attachments = \"".$templates->get("myshowcase_new_attachments")."\";");
		}

		if($mybb->request_method == "post" && $mybb->input['submit'])
		{
			// Decide on the visibility of this post.
			if($me->modnewedit && !$me->userperms['canmodapprove'])
			{
				$approved = 0;
				$approved_by = 0;
			}
			else
			{
				$approved = 1;
				$approved_by = $mybb->user['uid'];
			}

			$plugins->run_hooks("myshowcase_do_newedit_start");

			// Set up showcase handler.
			require_once MYBB_ROOT."inc/datahandlers/myshowcase_dh.php";
			if($mybb->input['action'] == "do_editshowcase")
			{
				$showcasehandler = new MyShowcaseDataHandler("update");
				$showcasehandler->action = 'edit';
			}
			else
			{
				$showcasehandler = new MyShowcaseDataHandler("insert");
				$showcasehandler->action = 'new';
			}

			//This is where the work is done

			// Verify incoming POST request
			verify_post_check($mybb->input['my_post_key']);

			// Set the post data that came from the input to the $post array.
			$default_data = array(
				"uid" => $showcase_data['uid'],
				"dateline" => $dateline,
				"approved" => $approved,
				"approved_by" => $approved_by,
				"posthash" => $posthash
				);

			//add showcase id if editing so we know what to update
			if($mybb->input['action'] == "do_editshowcase")
			{
				$default_data = array_merge($default_data, array("gid"=>intval($mybb->input['gid'])));
			}

			//add showcase specific fields
			reset($showcase_fields_enabled);
			$submitted_data = array();
			foreach($showcase_fields_enabled as $fname => $ftype)
			{
				if($ftype == 'db' || $ftype == 'radio')
				{
					$submitted_data[$fname] = intval($mybb->input['myshowcase_field_'.$fname]);
				}
				elseif($ftype == 'checkbox')
				{
					$submitted_data[$fname] = (isset($mybb->input['myshowcase_field_'.$fname]) ? 1 : 0);
				}
				else
				{
					$submitted_data[$fname] = $db->escape_string($mybb->input['myshowcase_field_'.$fname]);
				}
			}

			//redefine the showcase_data
			$showcase_data = array_merge($default_data, $submitted_data);

			//send data to handler
			$showcasehandler->set_data($showcase_data);

			// Now let the showcase handler do all the hard work.
			$valid_showcase = $showcasehandler->validate_showcase();

			$showcase_errors = array();

			// Fetch friendly error messages if this is an invalid showcase
			if(!$valid_showcase)
			{
				$showcase_errors = $showcasehandler->get_friendly_errors();
			}
			if(count($showcase_errors) > 0)
			{
				$error = inline_error($showcase_errors);
				eval("\$showcase_page = \"".$templates->get("error")."\";");

			}
			else
			{
				//update showcase
				if($mybb->input['action'] == "do_editshowcase")
				{
					$insert_showcase = $showcasehandler->update_showcase();
					$showcaseid = intval($mybb->input['gid']);
				}
                //insert showcase
				else
				{
					$insert_showcase = $showcasehandler->insert_showcase();
					$showcaseid = $insert_showcase['gid'];
				}

				$plugins->run_hooks("myshowcase_do_newedit_end");

				//fix url insert variable to update results
				$item_viewcode = str_replace('{gid}', $showcaseid, SHOWCASE_URL_VIEW);

				$redirect_newshowcase = $lang->redirect_myshowcase_new.''.$lang->redirect_myshowcase.''.$lang->sprintf($lang->redirect_myshowcase_return, $showcase_url);
				redirect($item_viewcode, $redirect_newshowcase);
				exit;
			}
		}
		else
		{
			$plugins->run_hooks("myshowcase_newedit_start");

			eval("\$showcase_page .= \"".$templates->get("myshowcase_new_top")."\";");

			reset($showcase_fields_enabled);
 			foreach ($showcase_fields_enabled as $fname => $ftype)
			{

				$temp = 'myshowcase_field_'.$fname;
				$field_header = $lang->$temp;

				$trow_style = ($trow_style == "trow1" ? "trow2" : "trow1");

				if($mybb->input['action'] == "edit")
				{
					$mybb->input['myshowcase_field_'.$fname] = htmlspecialchars_uni(stripslashes($showcase_data[$fname]));
				}

				switch( $ftype)
				{
					case "textbox":
					case "url":
						$showcase_field_width = 50;
						$showcase_field_rows = '';
						$showcase_field_name = 'myshowcase_field_'.$fname;
						$showcase_field_value = $mybb->input['myshowcase_field_'.$fname];
						$showcase_field_enabled = '';//($showcase_fields_enabled[$fname] != 1 ? 'disabled' : '');
						$showcase_field_checked = '';
						$showcase_field_options = 'maxlength="'.$showcase_fields_max_length[$fname].'"';
						eval("\$showcase_field_input = \"".$templates->get("myshowcase_field_textbox")."\";");
					break;

					case "textarea":
						$showcase_field_width = 100;
						$showcase_field_rows = $showcase_fields_max_length[$fname];
						$showcase_field_name = 'myshowcase_field_'.$fname;
						$showcase_field_value = $mybb->input['myshowcase_field_'.$fname];
						$showcase_field_enabled = '';//($showcase_fields_enabled[$fname] != 1 ? 'disabled' : '');
						$showcase_field_checked = '';
						$showcase_field_options = '';
						eval("\$showcase_field_input = \"".$templates->get("myshowcase_field_textarea")."\";");
					break;

					case "radio":
						$showcase_field_width = 50;
						$showcase_field_rows = '';
						$showcase_field_name = 'myshowcase_field_'.$fname;
						$showcase_field_enabled = '';//($showcase_fields_enabled[$fname] != 1 ? 'disabled' : '');
						$showcase_field_options = '';

						$query = $db->simple_select("myshowcase_field_data", "*", "setid=".$me->fieldsetid." AND name='".$fname."' AND valueid != 0", array("order_by" => "disporder"));
						if($db->num_rows($query) == 0)
						{
							error($lang->myshowcase_db_no_data);
						}

						$showcase_field_input = '';
						while($results = $db->fetch_array($query))
						{
							$showcase_field_value = $results['valueid'];
							$showcase_field_checked = ($mybb->input['myshowcase_field_'.$fname] == $results['valueid'] ? ' checked' : '');
							$showcase_field_text = $results['value'];
							eval("\$showcase_field_input .= \"".$templates->get("myshowcase_field_radio")."\";");
						}
					break;

					case "checkbox":
						$showcase_field_width = 50;
						$showcase_field_rows = '';
						$showcase_field_name = 'myshowcase_field_'.$fname;
						$showcase_field_value = '1';
						$showcase_field_enabled = '';//($showcase_fields_enabled[$fname] != 1 ? 'disabled' : '');
						$showcase_field_checked = ($mybb->input['myshowcase_field_'.$fname] == 1 ? ' checked="checked"' : '');
						$showcase_field_options = '';
						eval("\$showcase_field_input = \"".$templates->get("myshowcase_field_checkbox")."\";");
					break;

					case "db":
						$showcase_field_width = 50;
						$showcase_field_rows = '';
						$showcase_field_name = 'myshowcase_field_'.$fname;
						$showcase_field_value = $mybb->input['myshowcase_field_'.$fname];
						$showcase_field_enabled = '';//($showcase_fields_enabled[$fname] != 1 ? 'disabled' : '');
						$showcase_field_checked = '';
						$query = $db->simple_select("myshowcase_field_data", "*", "setid=".$me->fieldsetid." AND name='".$fname."' AND valueid != 0", array("order_by" => "disporder"));
						if($db->num_rows($query) == 0)
						{
							error($lang->myshowcase_db_no_data);
						}

						$showcase_field_options = ($mybb->input['action'] == "new" ? '<option value=0>&lt;Select&gt;</option>' : '');
						while($results = $db->fetch_array($query))
						{
							$showcase_field_options .= '<option value="'.$results['valueid'].'" '.($showcase_field_value == $results['valueid'] ? ' selected' : '') .'>'.$results['value'].'</option>';
						}
						eval("\$showcase_field_input = \"".$templates->get("myshowcase_field_db")."\";");
					break;
				}

				$field_header = ($showcase_fields_require[$fname] ? "<strong>".$field_header." *</strong>" : $field_header);
				eval("\$showcase_page .= \"".$templates->get("myshowcase_new_fields")."\";");
			}

			$plugins->run_hooks("myshowcase_newedit_end");

			eval("\$showcase_page .= \"".$templates->get("myshowcase_new_bottom")."\";");
		}
	break;
	}
}

?>
